#pragma once

/*
 *						 WiiR̃Rg[NX
 *															쐬:cCcPFC鐲đ
 *															ver. 0.4.0
 * WiiR̊{IȑsNXłD
 * 0.4.0:qNX̃\bhveNgŐeNX
 *
*/

//Windows Device Driver Kit̃CũC|[g
#pragma comment( lib , "setupapi.lib")
#pragma comment( lib , "hid.lib")

#include <windows.h>
#include <iostream>
#include <setupapi.h>

#include "guiddef.h"

extern "C"{
#include "hidsdi.h"
}

class CWiiRemoteCntl
{
private:
	//wiiRnhp
	HANDLE handle;
	PSP_INTERFACE_DEVICE_DETAIL_DATA DeviceDetail;
	PHIDP_PREPARSED_DATA pp;
	//HIDfoCXop
	GUID* guid;
	//f[^͂ButtonData̍\̂Ɍʂ
	bool Analysis(void);
	//HIDfoCX̌o
	GUID* GetHidGuid(void);
	//HIDfoCX̏ڍ׏̎擾
	PSP_INTERFACE_DEVICE_DETAIL_DATA GetHidDeviceDetail( GUID* guid, int index);
	//foCX̏i[pϐ
	HIDP_CAPS caps;

	OVERLAPPED overlapped;
	unsigned long count;
	//BYTE wii[255];
	unsigned char inputReport[255];
	int devNum;

public:
	//RXgN^
	CWiiRemoteCntl(void);
	//fXgN^
	virtual ~CWiiRemoteCntl(void);

	virtual bool Initialize(void) = 0;
	virtual bool RequestCalib(BYTE* input) = 0;
	virtual bool RequestCalibExt(BYTE* input) = 0;
	virtual bool RequestData(BYTE* input) = 0;
	virtual bool RequestState(BYTE* input) = 0;
	virtual bool SetLED_Vibration(BYTE setCommand) = 0;
	virtual bool Finalize(void) = 0;

protected:

	BYTE mReadBuff[255];
	BYTE mReadBuff_17[255];
	BYTE wiiRemoteCalibrationData[255];
	BYTE wiiRemoteExtensionCalibrationData[255];
	BYTE wiiStateData[255];
	BYTE wiiExtState[255];

	int inputLength;
	bool isExtension;
	BYTE LEDandVibrationCommand;

	void DebugWriteLine(BYTE *dispBuff,int displaySize);
	void WriteData(int address, int data);
	bool Report_0x12(BYTE data1, BYTE data2);

	bool GetStatus();

	//WiiŘo
	bool FindWiiRemote();
	// Wiiւ̑MR}h
	bool WriteReport(BYTE *outputReport);
	//{^f[^̎擾R}h
	bool ReadReport(BYTE *inputReport,int *len);

	BYTE* ReadReport();

	bool WiiClosed();

};
