#include "WiiRemoteConvert.h"

WiiRemoteConvert::WiiRemoteConvert(void)
{
}

WiiRemoteConvert::~WiiRemoteConvert(void)
{
}

void WiiRemoteConvert::SetWiiRemoteCalibration(BYTE *buff)
{
	mWiiRemoteState.AccelCalibrationInfo.X0 = buff[6];
	mWiiRemoteState.AccelCalibrationInfo.Y0 = buff[7];
	mWiiRemoteState.AccelCalibrationInfo.Z0 = buff[8];
	mWiiRemoteState.AccelCalibrationInfo.XG = buff[10];
	mWiiRemoteState.AccelCalibrationInfo.YG = buff[11];
	mWiiRemoteState.AccelCalibrationInfo.ZG = buff[12];
}

void WiiRemoteConvert::ParseButtons(BYTE *buff)
{
	mWiiRemoteState.ButtonState.A		= (buff[2] & 0x08) != 0;
	/*mWiiRemoteState.ButtonState.B		= (buff[2] & 0x04) != 0;
	mWiiRemoteState.ButtonState.Minus	= (buff[2] & 0x10) != 0;
	mWiiRemoteState.ButtonState.Home	= (buff[2] & 0x80) != 0;
	mWiiRemoteState.ButtonState.Plus	= (buff[1] & 0x10) != 0;
	mWiiRemoteState.ButtonState.One	    = (buff[2] & 0x02) != 0;
	mWiiRemoteState.ButtonState.Two   	= (buff[2] & 0x01) != 0;
	mWiiRemoteState.ButtonState.Up	    = (buff[1] & 0x08) != 0;
	mWiiRemoteState.ButtonState.Down	= (buff[1] & 0x04) != 0;
	mWiiRemoteState.ButtonState.Left	= (buff[1] & 0x01) != 0;
	mWiiRemoteState.ButtonState.Right	= (buff[1] & 0x02) != 0;*/
}

void WiiRemoteConvert::ParseAccel(BYTE *buff)
{
	mWiiRemoteState.AccelState.RawValues.X = buff[3];
	mWiiRemoteState.AccelState.RawValues.Y = buff[4];
	mWiiRemoteState.AccelState.RawValues.Z = buff[5];

	mWiiRemoteState.AccelState.Values.X = (int)((double)(mWiiRemoteState.AccelState.RawValues.X - mWiiRemoteState.AccelCalibrationInfo.X0)
			/(double)(mWiiRemoteState.AccelCalibrationInfo.XG - mWiiRemoteState.AccelCalibrationInfo.X0)*100);
	mWiiRemoteState.AccelState.Values.Y = (int)((double)(mWiiRemoteState.AccelState.RawValues.Y - mWiiRemoteState.AccelCalibrationInfo.Y0)
			/(double)(mWiiRemoteState.AccelCalibrationInfo.YG - mWiiRemoteState.AccelCalibrationInfo.Y0)*100);
	mWiiRemoteState.AccelState.Values.Z = (int)((double)(mWiiRemoteState.AccelState.RawValues.Z - mWiiRemoteState.AccelCalibrationInfo.Z0)
			/(double)(mWiiRemoteState.AccelCalibrationInfo.ZG - mWiiRemoteState.AccelCalibrationInfo.Z0)*100);
}
